using GrapeCity.ActiveReports;
using GrapeCity.ActiveReports.Aspnet.Viewer;
using GrapeCity.ActiveReports.Data;
using Microsoft.Owin;
using Owin;
using System.Data;
using System.Data.OleDb;
using System.IO;
using System.Reflection;
using System.Runtime.InteropServices.WindowsRuntime;
using System.Web.Routing;
using System.Xml;

[assembly: OwinStartup(typeof(JSViewer_MVC.Startup))]

namespace JSViewer_MVC
{
    public class Startup
    {
        private static readonly string CurrentDir = Path.GetDirectoryName(Assembly.GetExecutingAssembly().GetName().CodeBase)?.Replace("file:\\", "");
        public static readonly DirectoryInfo ReportsDirectory = new DirectoryInfo(Path.Combine(CurrentDir, "Reports"));

        public void Configuration(IAppBuilder app)
        {
            app.UseErrorPage();

            app.UseReporting(settings =>
            {
                settings.UseCustomStore((reportId) => GetReport(reportId));
                settings.UseCompression = true;
            });

            RouteTable.Routes.RouteExistingFiles = true;
        }

        public object GetReport(string param)
        {
            if (param == "CodeReport.cs")
            {
                CodeReport rpt = new CodeReport();

                rpt.DataSource = new JsonDataSource() { ConnectionString = "jsondoc=http://localhost:58720/data", JsonPath = "$.[*]" }; // Using JSON DataSource to get data from controller at runtime
                rpt.Parameters.Add(new GrapeCity.ActiveReports.SectionReportModel.Parameter() { Key = "parameter1", Type = GrapeCity.ActiveReports.SectionReportModel.Parameter.DataType.String, PromptUser = false });

                return rpt;
            }
            return null;
        }
    }
}